// DialogWidget.h //

#ifndef __DIALOGWIDGET_H
#define __DIALOGWIDGET_H

#include "Widget.h"

/** This widget displays a dialog **/

class DialogWidget : public Widget
{
  public:
    /// constructor takes the Dialog object
    DialogWidget (int iYSize, int iXSize, int iYPos, int iXPos
        , const string& rkoStrMsg);

    /// Dialog window y dimension
    static const int c_kiYSize;

    /// Dialog window x dimension
    static const int c_kiXSize;

    /// Dialog window y position
    static const int c_kiYPos;

    /// Dialog window x position
    static const int c_kiXPos;

    /// this window gets the keyboard focus
    virtual int KeyFocus (void);

    /// application logic of the particular type of widget
    virtual void Draw (void);


  protected:
    /// display the current state of the die 
    virtual void DrawDialog (void);

  private:
    string m_oStrMsg;
};

#endif //__DIALOGWIDGET_H

// DialogWidget.h //
