/* GraphDieWidget.cpp */

#include "GraphDieWidget.h"
#include <sstream>
#include <string>

#include "UI.h"

using std::stringstream;

GraphDieWidget :: GraphDieWidget (Die *poDie)
  : DieWidget(poDie)
{
  m_poBitmaps = new map<int, string>;
  (*m_poBitmaps)[0] = 
    "       " 
    " ..... " 
    " ..... " 
    " ..... " 
    "       ";
  (*m_poBitmaps)[1] = 
    "       " 
    "       " 
    "   O   " 
    "       "
    "       ";
  (*m_poBitmaps)[2] = 
    "       " 
    " O     " 
    "       " 
    "     O " 
    "       ";
  (*m_poBitmaps)[3] = 
    "       " 
    " O     " 
    "   O   " 
    "     O " 
    "       ";
  (*m_poBitmaps)[4] = 
    "       " 
    " O   O " 
    "       " 
    " O   O " 
    "       ";
  (*m_poBitmaps)[5] = 
    "       " 
    " O   O " 
    "   O   " 
    " O   O " 
    "       ";
  (*m_poBitmaps)[6] = 
    "       " 
    " O O O " 
    "       " 
    " O O O " 
    "       ";
  (*m_poBitmaps)[7] = 
    "       " 
    "   |   " 
    "   |   " 
    "   |   " 
    "       ";
  (*m_poBitmaps)[8] = 
    "       " 
    "    /  " 
    "   /   " 
    "  /    " 
    "       ";
  (*m_poBitmaps)[9] = 
    "       " 
    "       " 
    " ----- " 
    "       " 
    "       ";
  (*m_poBitmaps)[10] = 
    "       " 
    "  \\    " 
    "   \\   " 
    "    \\  " 
    "       ";
}

void GraphDieWidget :: DrawDie (void)
{
  int iAttri = COLOR_PAIR(COLORPAIR_5)|WA_BOLD;
  DrawBitmap ((*m_poBitmaps)[GetDie().GetFaceVal()], iAttri);
}

void GraphDieWidget :: Roll (void)
{
  int iAttri = COLOR_PAIR(COLORPAIR_5)|WA_BOLD;
  for(int i=0; i<12; i++)
  {
    napms(100);
    DrawBitmap ((*m_poBitmaps)[7+(i%4)], iAttri);
    Refresh();
  }
}

// GraphDieWidget.cpp //
