// PlayerWidget.h //

#ifndef __PLAYERWIDGET_H
#define __PLAYERWIDGET_H

#include <vector>
#include "Widget.h"
#include "Player.h"

using std::vector;

/** This widget displays player names & their current position on board */

class PlayerWidget : public Widget
{
  public:
    /// constructor takes the Player object
    PlayerWidget (vector< Player > *poPlayer);

    /// Player window menu height
    static const int c_kiLHeight = 1;

    /// Player window id column width
    static const int c_kiIDWidth = 3;

    /// Player window name column width
    static const int c_kiNWidth = 16;

    /// Player window postion column width
    static const int c_kiPWidth = 4;
    
    /// Player window y dimension
    static const int c_kiYSize = c_kiLHeight * 7 + 1;

    /// Player window x dimension
    static const int c_kiXSize = c_kiIDWidth + c_kiNWidth + c_kiPWidth;

    /// Player window y position
    static const int c_kiYPos = 1;

    /// Player window x position
    static const int c_kiXPos = 52;

    /// No. of Players
    static const int c_kiMaxPlayers = 6;

    /// application logic of the particular type of widget
    virtual void Draw (void);
    
    /// this window gets the keyboard focus
    virtual int KeyFocus (void);
    
    /// this gives no. of players 
    int GetPlayerNum (void);

    /// clear up the vector of players, restoring index to 0
    void Clear (void);

  protected:
    /// display the current state of the players
    virtual void DrawPlayer (void);

  private:
    /// the player widget
    vector< Player > *m_poVecPlayers;

    /// the current player's index
    int m_iCurrIndex;

    /// the edit buffer
    string m_oStrEditBuf;
};

#endif //__PLAYERWIDGET_H

// PlayerWidget.h //
